// $Id: init_array.h,v 1.1 2019/03/06 22:23:34 leavens Exp leavens $

// The following is the type of functions mapping ints to doubles,
// which is used to create test data. Think of such a function
// as describing (by a rule) the ith element of an array of doubles.
typedef double (*RuleFun)(int i);

// Requires: for all 0 <= i and i < sz :: i is a legal index into data
// and rule is defined on i and rule has no effects when applied to i.
// Effect: for all 0 <= i and i < sz :: data[i] == rule(i)
extern void init_array(double data[], RuleFun rule, int sz);

// Rule function examples that are in init_array.c are declared below.

// Ensures: result is (double) i
extern double castToDouble(int i);
// Ensures: result is (double) i*i
extern double square(int i);
// Ensures: result is i+10.0
extern double plus10(int i);
// Ensures: result is 50.0
extern double fifty(int i);
// Ensures: result is e**i;
extern double eToPower(int i);
// Ensures: result is log(i+10.0);
extern double logePlus10(int i);
