// $Id: test_average.c,v 1.3 2019/03/06 22:23:34 leavens Exp $
// compile with:
// gcc -g -Wall -pedantic tap.c approx.c init_array.c average.c test_average.c -o test_average
#include <stdio.h>
#include <stdlib.h>
#include "tap.h"
#include "approx.h"
#include "init_array.h"
#include "average.h"

// Testing for average()
int main() {
    double data[10];
    double small = 0.00001;
    data[0] = 0.0;
    data[1] = 1.0;
    ok(approx(average(data, 2), 0.5, small), "average of 0.0 and 1.0");

    // the same test as above, but written using init_array and the rule castToDouble
    init_array(data, castToDouble, 2);
    ok(approx(average(data, 2), 0.5, small), "average of 0.0 and 1.0 with rule");

    init_array(data, square, 7);
    // the following shows some code that can be useful for debugging, if you uncomment the printf
    double temp = average(data, 7);
    printf("average of squares is %lf\n", temp);
    ok(approx(temp, 13.0, small), "average of the squares from 0 to 6 (inclusive)");
    init_array(data, plus10, 10);
    ok(approx(average(data, 10), 14.5, small), "average of i+10 for i from 0 to 9 (inclusive)");
    init_array(data, fifty, 9);
    ok(approx(average(data, 9), 50.0, small), "average of 50.0 entries");
    init_array(data, eToPower, 10);
    ok(approx(average(data, 10), 1281.830805, small), "average of e**i for i from 0 to 9 (inclusive)");
    init_array(data, logePlus10, 10);
    temp = average(data, 10);
    printf("average of logePlus10 is %lf\n", temp);
    ok(approx(temp, 2.653806, small), "average of logePlus10(i) for i from 0 to 9 (inclusive)");
    return exit_status();
}
